// ChoosDir.cpp : implementation file
//

#include "stdafx.h"
#include "ChkRes.h"

#include <direct.h>
#include <dlgs.h>
#include "ChoosDir.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChooseDir

IMPLEMENT_DYNAMIC(CChooseDir, CFileDialog)

CChooseDir::CChooseDir(BOOL bOpenFileDialog, LPCTSTR lpszDefExt, LPCTSTR lpszFileName,
  DWORD dwFlags, LPCTSTR lpszFilter, CWnd* pParentWnd) :
    CFileDialog(bOpenFileDialog, lpszDefExt, lpszFileName, 
      dwFlags |= OFN_ENABLETEMPLATE, lpszFilter, pParentWnd)
{
  m_ofn.hInstance = AfxGetResourceHandle();
  m_ofn.lpTemplateName = MAKEINTRESOURCE(CChooseDir::IDD);
  m_ofn.Flags &= ~OFN_EXPLORER;

  //{{AFX_DATA_INIT(CChooseDir)
  //}}AFX_DATA_INIT
}

void CChooseDir::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(CChooseDir)
  DDX_Control(pDX, IDC_DIRNAME, m_CtrlDirName);
  //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChooseDir, CFileDialog)
  //{{AFX_MSG_MAP(CChooseDir)
  ON_WM_PAINT()
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CChooseDir::OnInitDialog() 
{
  CString szTemp;

  CenterWindow();

  GetDlgItem(stc2)->ShowWindow(SW_HIDE);
  GetDlgItem(stc3)->ShowWindow(SW_HIDE);
  GetDlgItem(edt1)->ShowWindow(SW_HIDE);
  GetDlgItem(lst1)->ShowWindow(SW_HIDE);
  GetDlgItem(cmb1)->ShowWindow(SW_HIDE);
  GetDlgItem(stc1)->ShowWindow(SW_HIDE);
  GetDlgItem(chx1)->ShowWindow(SW_HIDE);
  GetDlgItem(psh15)->EnableWindow(FALSE);

  SetDlgItemText(edt1, "Junk");

  // Need to fill in my edit control (IDC_DIRNAME)
  CListBox* pList = (CListBox*)GetDlgItem(lst2);
  int iIndex = pList->GetCurSel();

  m_szDirName.Empty();
	
  if (iIndex != LB_ERR)
  {
    pList->GetText(iIndex, szTemp);

    for (int i = 0; i <= iIndex; i++)
    {
      pList->GetText(i, szTemp);
      
      if (i > 1)
      {
	m_szDirName += "\\";
	m_szDirName += szTemp;
      }
      else
	m_szDirName += szTemp;
    }
    m_szDirName.MakeUpper();
    ((CEdit*)GetDlgItem(IDC_DIRNAME))->SetWindowText(m_szDirName);
  }

  GetDlgItem(lst2)->SetFocus();

  m_bDlgJustCameUp = TRUE;

  CFileDialog::OnInitDialog();
	
  return FALSE;	  // return TRUE unless you set the focus to a control
		  // EXCEPTION: OCX Property Pages should return FALSE
}

void CChooseDir::OnPaint() 
{
  CPaintDC dc(this); // device context for painting
	
  if (m_bDlgJustCameUp)
  {
    m_bDlgJustCameUp = FALSE;
    SendDlgItemMessage(lst2, LB_SETCURSEL, 0, 0L);
  }
  // Do not call CFileDialog::OnPaint() for painting messages
}

void CChooseDir::OnLBSelChangedNotify(UINT nIDBox, UINT iCurSel, UINT nCode)
{
  CString szTemp;
  CListBox* pList = (CListBox*)GetDlgItem(lst2);

  int iIndex = pList->GetCurSel();
  m_szDirName.Empty();

  if (iIndex != LB_ERR)
  {
    pList->GetText(iIndex, szTemp);

    for (int i = 0; i <= iIndex; i++)
    {
      pList->GetText(i, szTemp);
      if (i > 1)
      {
	m_szDirName += "\\";
	m_szDirName += szTemp;
      }
      else
	m_szDirName += szTemp;
    }
    ((CEdit*)GetDlgItem(IDC_DIRNAME))->SetWindowText(m_szDirName);
  }
}

BOOL CChooseDir::OnFileNameOK(void)
{
  CString szDrive;
  CString szMessage;
  int iResult;

  m_CtrlDirName.GetWindowText(m_szDirName);
  szDrive = m_szDirName.Left(3);
  iResult = m_szDirName.FindOneOf("*?|/<>\"");

  if (iResult >= 0)
  {
    szMessage.Format("%s is not a valid pathname.", m_szDirName);
    AfxMessageBox(szMessage, MB_OK);
    return TRUE;
  }
	
  if (_chdir(m_szDirName))
  {
    szMessage.Format("Directory %s does not exist.\nCreate this directory?", m_szDirName);
    iResult = AfxMessageBox(szMessage, MB_YESNO);
    if (iResult == IDYES)
    {
      // Create the new directory:
      iResult = _mkdir(m_szDirName);
      if (iResult)
      {
	szMessage.Format("There was a problem creating %s.\nThe new directory was not created.", m_szDirName);
	AfxMessageBox(szMessage, MB_OK);
	return TRUE;
      }
    }
    else
      return TRUE;
  }

  char szBuffer[MAX_PATH];
  szMessage = m_szDirName + "\\" + m_ofn.lpstrFileTitle;
  strcpy(szBuffer, szMessage);
  strcpy(m_ofn.lpstrFile, szBuffer);
  m_pofnTemp->nFileOffset = m_szDirName.GetLength() + 1;
  m_pofnTemp->nFileExtension = szMessage.GetLength();
  return FALSE;
}
